#include "../port/portfns.h"

void	archinit(void);
int	cistrcmp(char*, char*);
int	cistrncmp(char*, char*, int);
void	clockcheck(void);
void	clockinit(void);
void	clockintr(Ureg*);
void	clockintrsched(void);
void	cpuidentify(void);
void	cpuidprint(void);
void	cycles(uvlong*);
void	dbgputc(int c);
void	dcacheenb(void);
void	dcflush(void*, ulong);
void	dczap(void*, ulong);
void	delay(int);
void	delayloopinit(void);
void	dmiss(void);
void*	dpalloc(int);
void	dumpregs(Ureg*);
void	eieio(void);
void	evenaddr(ulong);
void	faultpower(Ureg*, ulong addr, int read);
void	flashprogpower(int);
void	fpinit(void);
void	fpgareset(void);
void	fprestore(FPsave*);
void	fpsave(FPsave*);
void	fptrap(Ureg*);
char*	getconf(char*);
ulong	getdar(void);
ulong	getdcmp(void);
ulong	getdec(void);
ulong	getdepn(void);
ulong	getdmiss(void);
ulong	getdsisr(void);
ulong	gethash1(void);
ulong	gethash2(void);
ulong	gethid0(void);
ulong	gethid1(void);
ulong	geticmp(void);
ulong	geticmp(void);
ulong	getimiss(void);
ulong	getimmr(void);
ulong	getmsr(void);
ulong	getpvr(void);
ulong	getrpa(void);
ulong	getsdr1(void);
ulong	getsr(int);
ulong	getsrr1(void);
ulong	gettbl(void);
ulong	gettbu(void);
void	gotopc(ulong);
void	hwintrinit(void);
void	icacheenb(void);
void	icflush(void*, ulong);
void	idle(void);
#define	idlehands()		/* nothing to do in the runproc */
void	imiss(void);
int	inb(int);
ulong	inl(int);
ushort	ins(int);
void	insb(int, void*, int);
void	insl(int, void*, int);
void	inss(int, void*, int);
void	intr(Ureg*);
void	intrenable(int, void (*)(Ureg*, void*), void*, char*);
void	intrdisable(int, void (*)(Ureg*, void*), void*, char*);
int	ioalloc(int, int, int, char*);
void	iofree(int);
void	ioinit(void);
int	iprint(char*, ...);
int	isaconfig(char*, int, ISAConf*);
void	kbdinit(void);
void	kbdreset(void);
void	kernelmmu(void);
void	kfpinit(void);
#define	kmapinval()
void	links(void);
void	vectordisable(Vctl *);
int	vectorenable(Vctl *);
void	intack(void);
void	intend(int);
int	intvec(void);
void	l2disable(void);
void	mathinit(void);
void	mmuinit(void);
void	mmusweep(void*);
void	mpicdisable(int);
void	mpicenable(int, Vctl*);
int	mpiceoi(int);
int	mpicintack(void);
int	newmmupid(void);
void	outb(int, int);
void	outl(int, ulong);
void	outs(int, ushort);
void	outsb(int, void*, int);
void	outsl(int, void*, int);
void	outss(int, void*, int);
int	pcicfgr16(Pcidev*, int);
int	pcicfgr32(Pcidev*, int);
int	pcicfgr8(Pcidev*, int);
void	pcicfgw16(Pcidev*, int, int);
void	pcicfgw32(Pcidev*, int, int);
void	pcicfgw8(Pcidev*, int, int);
void	pcihinv(Pcidev*);
void	pcireset(void);
int	pciscan(int, Pcidev **);
void	pcisetbme(Pcidev*);
void	procsave(Proc*);
void	procsetup(Proc*);
void	putcasid(ulong);
void	putdcmp(ulong);
void	putdec(ulong);
void	puthash1(ulong);
void	puthash2(ulong);
void	puthid0(ulong);
void	puthid1(ulong);
void	puthid2(ulong);
void	puticmp(ulong);
void	puticmp(ulong);
void	putmsr(ulong);
void	putrpa(ulong);
void	putsdr1(ulong);
void	putsdr1(ulong);
void	putsr(int, ulong);
void	putsrr1(ulong);
void	raveninit(void);
void	screeninit(void);
int	screenprint(char*, ...);		/* debugging */
int	segflush(void*, ulong);
void	sethvec(int, void (*)(void));
void	setmvec(int, void (*)(void), void (*)(void));
void	sharedseginit(void);
void	console(void);
void	sync(void);
int	tas(void*);
void	timeradd(Timer *);
void	timerdel(Timer *);
void	timerinit(void);
void	tlbflush(ulong);
void	tlbflushall(void);
void	tlbld(ulong);
void	tlbli(ulong);
void	tlbvec(void);
void	touser(void*);
void	trapinit(void);
void	trapvec(void);
void	uartinstall(void);
void	uartwait(void);	/* debugging */
#define	userureg(ur) (((ur)->status & MSR_PR) != 0)
#define	waserror()	(up->nerrlab++, setlabel(&up->errlab[up->nerrlab-1]))
void	watchreset(void);
void	wbflush(void);
#define KADDR(a)	((void*)((ulong)(a)|KZERO))
#define PADDR(a)	((((ulong)(a)&0xf0000000)==0xf0000000)?(ulong)(a):((ulong)(a)&~KZERO))
#define coherence()	eieio()
ulong pcibarsize(Pcidev *, int);
void pciclrbme(Pcidev*);
uchar pciipin(Pcidev *, uchar);
Pcidev* pcimatch(Pcidev*, int, int);
Pcidev* pcimatchtbdf(int);
void	procrestore(Proc*);

#ifdef ucuconf
extern ulong getpll(void);
extern ulong getl2cr(void);
extern void putl2cr(ulong);
#endif
