/* sorted by unicode value */
Htmlchar htmlchars[] =
{
	{ L'"',	"&quot;" },
	{ L'&',	"&amp;" },
	{ L'<',	"&lt;" },
	{ L'>',	"&gt;" },
	{ L'¡',	"&#161;" },
	{ L'¢',	"&#162;" },
	{ L'£',	"&#163;" },
	{ L'¤',	"&#164;" },
	{ L'¥',	"&#165;" },
	{ L'¦',	"&#166;" },
	{ L'§',	"&#167;" },
	{ L'¨',	"&#168;" },
	{ L'©',	"&#169;" },
	{ L'ª',	"&#170;" },
	{ L'«',	"&#171;" },
	{ L'¬',	"&#172;" },
	{ L'­',	"&#173;" },
	{ L'®',	"&#174;" },
	{ L'¯',	"&#175;" },
	{ L'°',	"&#176;" },
	{ L'±',	"&#177;" },
	{ L'²',	"&#178;" },
	{ L'³',	"&#179;" },
	{ L'´',	"&#180;" },
	{ L'µ',	"&#181;" },
	{ L'¶',	"&#182;" },
	{ L'·',	"&#183;" },
	{ L'¸',	"&#184;" },
	{ L'¹',	"&#185;" },
	{ L'º',	"&#186;" },
	{ L'»',	"&#187;" },
	{ L'¼',	"&#188;" },
	{ L'½',	"&#189;" },
	{ L'¾',	"&#190;" },
	{ L'¿',	"&#191;" },
	{ L'À',	"&Agrave;" },
	{ L'Á',	"&Aacute;" },
	{ L'Â',	"&Acirc;" },
	{ L'Ã',	"&Atilde;" },
	{ L'Ä',	"&Auml;" },
	{ L'Å',	"&Aring;" },
	{ L'Æ',	"&AElig;" },
	{ L'Ç',	"&Ccedil;" },
	{ L'È',	"&Egrave;" },
	{ L'É',	"&Eacute;" },
	{ L'Ê',	"&Ecirc;" },
	{ L'Ë',	"&Euml;" },
	{ L'Ì',	"&Igrave;" },
	{ L'Í',	"&Iacute;" },
	{ L'Î',	"&Icirc;" },
	{ L'Ï',	"&Iuml;" },
	{ L'Ð',	"&ETH;" },
	{ L'Ñ',	"&Ntilde;" },
	{ L'Ò',	"&Ograve;" },
	{ L'Ó',	"&Oacute;" },
	{ L'Ô',	"&Ocirc;" },
	{ L'Õ',	"&Otilde;" },
	{ L'Ö',	"&Ouml;" },
	{ L'×',	"x" },
	{ L'Ø',	"&Oslash;" },
	{ L'Ù',	"&Ugrave;" },
	{ L'Ú',	"&Uacute;" },
	{ L'Û',	"&Ucirc;" },
	{ L'Ü',	"&Uuml;" },
	{ L'Ý',	"&Yacute;" },
	{ L'Þ',	"&THORN;" },
	{ L'ß',	"&szlig;" },
	{ L'à',	"&agrave;" },
	{ L'á',	"&aacute;" },
	{ L'â',	"&acirc;" },
	{ L'ã',	"&atilde;" },
	{ L'ä',	"&auml;" },
	{ L'å',	"&aring;" },
	{ L'æ',	"&aelig;" },
	{ L'ç',	"&ccedil;" },
	{ L'è',	"&egrave;" },
	{ L'é',	"&eacute;" },
	{ L'ê',	"&ecirc;" },
	{ L'ë',	"&euml;" },
	{ L'ì',	"&igrave;" },
	{ L'í',	"&iacute;" },
	{ L'î',	"&icirc;" },
	{ L'ï',	"&iuml;" },
	{ L'ð',	"&eth;" },
	{ L'ñ',	"&ntilde;" },
	{ L'ò',	"&ograve;" },
	{ L'ó',	"&oacute;" },
	{ L'ô',	"&ocirc;" },
	{ L'õ',	"&otilde;" },
	{ L'ö',	"&ouml;" },
	{ L'ø',	"&oslash;" },
	{ L'ù',	"&ugrave;" },
	{ L'ú',	"&uacute;" },
	{ L'û',	"&ucirc;" },
	{ L'ü',	"&uuml;" },
	{ L'ý',	"&yacute;" },
	{ L'þ',	"&thorn;" },
	{ L'ÿ',	"&yuml;" },
	{ L'•',	"*" },
	{ L'™',	"(tm)" },
	{ L'←', 	"<-" },
	{ L'↑', 	"^" },
	{ L'→', 	"->" },
	{ L'↓', 	"v" },
	{ L'≠',	"!=" },
	{ L'≤', 	"<=" },
	{ L'□',	"&#164;" },
	{ L'◊',	"&#186;" },
};

/* unsorted */
Troffchar troffchars[] =
{
	{ "A*", "&Aring;", },
	{ "o\"", "&ouml;", },
	{ "ff", "ff", },
	{ "fi", "fi", },
	{ "fl", "fl", },
	{ "Fi", "ffi", },
	{ "ru", "_", },
	{ "em", "--", },
	{ "en", "-", },
	{ "\\-", "&#173;", },
	{ "14", "&#188;", },
	{ "12", "&#189;", },
	{ "co", "&#169;", },
	{ "de", "&#176;", },
	{ "dg", "&#161;", },
	{ "fm", "&#180;", },
	{ "rg", "&#174;", },
	{ "bu", "*", },
	{ "sq", "&#164;", },
	{ "hy", "&#173;", },
	{ "pl", "+", },
	{ "mi", "-", },
	{ "mu", "&#215;", },
	{ "di", "&#247;", },
	{ "eq", "=", },
	{ "==", "==", },
	{ ">=", ">=", },
	{ "<=", "<=", },
	{ "!=", "!=", },
	{ "+-", "&#177;", },
	{ "no", "&#172;", },
	{ "sl", "/", },
	{ "ap", "&", },
	{ "~=", "~=", },
	{ "pt", "oc", },
	{ "gr", "GRAD", },
	{ "->", "->", },
	{ "<-", "<-", },
	{ "ua", "^", },
	{ "da", "v", },
	{ "is", "Integral", },
	{ "pd", "DIV", },
	{ "if", "oo", },
	{ "sr", "-/", },
	{ "sb", "(~", },
	{ "sp", "~)", },
	{ "cu", "U", },
	{ "ca", "(^)", },
	{ "ib", "(=", },
	{ "ip", "=)", },
	{ "mo", "C", },
	{ "es", "&Oslash;", },
	{ "aa", "&#180;", },
	{ "ga", "`", },
	{ "ci", "O", },
	{ "L1", "DEATHSTAR", },
	{ "sc", "&#167;", },
	{ "dd", "++", },
	{ "lh", "<=", },
	{ "rh", "=>", },
	{ "lt", "(", },
	{ "rt", ")", },
	{ "lc", "|", },
	{ "rc", "|", },
	{ "lb", "(", },
	{ "rb", ")", },
	{ "lf", "|", },
	{ "rf", "|", },
	{ "lk", "|", },
	{ "rk", "|", },
	{ "bv", "|", },
	{ "ts", "s", },
	{ "br", "|", },
	{ "or", "|", },
	{ "ul", "_", },
	{ "rn", " ", },
	{ "**", "*", },
	{ nil, nil, },
};
